package com.chelvc.cloud.vehicle.client.dto;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.io.Serializable;
import java.util.List;

/**
 * 用户商家购物车
 *
 * @author liude
 * @date 2024/2/21
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class MerchantCartItemDTO implements Serializable {
    /**
     * 购物车商品信息
     */
    private List<OmsCartItemDTO> cartItems;
    /**
     * 商家信息
     */
    private MerchantDTO merchantDTO;
}
