package com.chelvc.cloud.vehicle.client.param;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import java.io.Serializable;

/**
 * @author valley
 * @date 2024/02/03 17:09
 **/
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class AssessRecoverModifyParam implements Serializable {

    @Min(value = 0, message = "评论id必须大于0")
    private String assessId;
    /**
     * 回复内容
     */
    @Max(value = 200, message = "评价内容不能超过200字")
    private String recoverMsg;
}
